# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_makeface
		def self.make_face(edges)
			eds=edges.select{|e| e && e.valid? && (e.is_a?Sketchup::Edge) }
			i=0
			length=edges.length
			while ((!eds.empty?) && (i<length))
				i+=1
				f=[]
				ed=eds.shift
				if ed && ed.valid? && (ed.is_a?Sketchup::Edge) && (ed.find_faces>0)
					if ed && ed.valid? && (ed.is_a?Sketchup::Edge)
						f=ed.faces.collect{|fa| fa.edges}.flatten.uniq
						eds -= f.select{|fe| fe.faces.length>2}
					end
				end
				Sketchup.status_text=(Strings["Make faces: "] + i.to_s + " / " + length.to_s)
			end
		end
		def self.main(mode)
			self.main_make_face
		end
		def self.main_make_face()
			model = Sketchup.active_model
			entities = model.active_entities
			selects=model.selection.to_a
			if selects.empty?
				UI.messagebox Strings["Select edges for Make Face"]
				return
			end
			faces=selects.grep(Sketchup::Face)
			face_entities=entities.grep(Sketchup::Face)
			selects=selects.select{|e| e && e.valid? && (e.is_a?Sketchup::Edge) }
			noselect= entities.to_a.select{|e| e && e.valid? && (e.is_a?Sketchup::Edge) } - selects
			groups=[]
			edge_remove=[]
			edges=edge_remove=[]
			edges=entities.select{|e| e && e.valid? && (e.is_a?Sketchup::Edge) } - noselect
			edge_remove=edges.select{|e| (e.start.edges.length==1 || e.end.edges.length==1)}
			curve=[]
			edge_remove.each{|e|
				es=edges.select{|ed| ed.curve && (ed.curve==e.curve)}
				curve+=es if es
			}
			edge_remove+=curve.uniq
			edge_remove_end=[]
			edge_remove.each{|e| edge_remove_end+=find_edges(e,selects)}
			# edge_remove_end+=(edges-edge_remove_end).select{|e| e && e.valid? && (e.is_a?Sketchup::Edge) && e.length<0.01}
			model.start_operation TOOL,true,false,false
			edge_remove_end.uniq!
			g=nil
			g=entities.add_group(edge_remove_end) if edge_remove_end.length>0
			ents= entities.select{|e| e && e.valid? && (e.is_a?Sketchup::Edge) } - noselect
			self.make_face(ents) if ents.length>0
			model.selection.clear
			if g && g.valid? && (g.is_a?Sketchup::Group)
				sels=g.explode
				model.selection.add sels.select{|e| e && e.valid? && (e.is_a?Sketchup::Edge)}
			end
			face_entities_new=entities.grep(Sketchup::Face)
			faces=(face_entities_new-face_entities)
			if !faces.empty?
				faces.each{|face|
                    face.reverse! if !face.normal.samedirection?(Z_AXIS)
					face_connect=face.edges.collect{|e| e.faces}.flatten.compact.uniq
					materials=(face_connect.collect{|f| f.material}).compact
					back_materials=(face_connect.collect{|f| f.back_material}).compact
					if !materials.empty?
						m=(materials.chunk{|e| e.name}).sort_by{|e| e[1].length}[-1]
						material=m[1][0]
						face.material=material if material
					end
					if !back_materials.empty?
						m=(back_materials.chunk{|e| e.name}).sort_by{|e| e[1].length}[-1]
						back_material=m[1][0]
						face.back_material=back_material if back_material
					end
				}
			end
			model.commit_operation
			rescue=> error
			p error,error.backtrace.join("\n")
			model.abort_operation
		end
		def self.find_edges(edge,all_connected)
			# all_connected= edge.all_connected.select{|e| (e.is_a?Sketchup::Edge)}
			edges=[edge]
			v=edge.vertices[0]
			# vers=[v]
			ed=v.edges-edges
			i=0
			while (ed.length==1) && (i< all_connected.length)
				i+=1
				edges<<ed[0]
				v=ed[0].other_vertex(v)
				# vers<<v
				ed= v.edges-edges
			end
			v=edge.vertices[1]
			# vers.unshift(v)
			ed = v.edges-edges
			i=0
			while (ed.length==1) && (i < all_connected.length)
				i+=1
				edges.unshift ed[0]
				v=ed[0].other_vertex(v)
				# vers.unshift v
				ed = v.edges-edges
			end
			return edges
		end
	end
end