# copyright: Huynh Duong Phuong Vi
# www.sketchupforyou.com
module S4U
	module S4u_makeface
        IS_WIN = Sketchup.platform == :platform_win
		IS_OSX = Sketchup.platform == :platform_osx
		Sketchup::require File.join(NAME,(NAME + "_code"))
		if  !self.const_defined?("Dir_s4u_name")
			S4U.instance_variable_set(:@s4u_menu,UI.menu("Plugins").add_submenu("Suforyou")) if !S4U.instance_variable_defined?(:@s4u_menu)
			menu=S4U.instance_variable_get :@s4u_menu
			@toolbar = UI::Toolbar.new("s4u-"+ TOOL)
			names=[[TOOL,NAME.downcase,Strings["Select edges for Make Face"] +'.']]
			if IS_OSX
				names.each{|n| n[1]+=".pdf"}
			else
				names.each{|n| n[1]+=".svg"}
			end
			(0..names.length-1).each{|i|
				cmd=UI::Command.new(names[i][0]){ self.main(i) }
				cmd.large_icon = names[i][1]
				cmd.small_icon = names[i][1]
				cmd.status_bar_text = names[i][2]
				cmd.tooltip= names[i][0]
				cmd.menu_text = names[i][0]
				menu.add_item cmd
				@toolbar=@toolbar.add_item cmd
				UI.add_context_menu_handler { |context_menu|
					context_menu.add_item(cmd) if Sketchup.active_model.selection.select{|e| e && e.valid? && e.is_a?(Sketchup::Edge)}.length>0
				}
			}
			@toolbar.show if @toolbar.get_last_state.abs == 1
		end
		Dir_s4u_name = File.join(File.dirname(@ext.extension_path),NAME)
	end
end